import * as estree from 'estree';
import * as eslint from 'eslint';
import * as json_schema from 'json-schema';

declare const rules: {
    [k: string]: {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {};
    } | {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {};
    } | {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {
            Program?: undefined;
        } | {
            Program(): void;
        };
    } | {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {};
    } | {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {
            Program(node: estree.Program): void;
        };
    } | {
        meta: {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                type: "integer";
                minimum: number;
                default: number;
            }[];
            messages: {
                spaceMetadata: string;
            };
            fixable: "code";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: json_schema.JSONSchema4 | json_schema.JSONSchema4[] | undefined;
            messages: {
                missingAttribute: string;
            };
            fixable: "code" | undefined;
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            schema: {
                enum: string[];
            }[];
            messages: {
                filenameExtension: string;
            };
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            fixable: "whitespace";
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                metadataRequired: string;
                moveMetadataToTop: string;
                noClosingMetadata: string;
                noCodeBetween: string;
                attributeNotStartsWithAtTheRate: string;
            };
            schema: {
                type: "object";
                properties: {
                    top: {
                        enum: string[];
                        default: string;
                    };
                };
                additionalProperties: false;
            }[];
        } | {
            docs: {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            } | {
                url: string;
                description: string;
                category: string;
            };
            type: "suggestion";
            messages: {
                attributeNotPrefixedBySpace: string;
            };
            schema: never[];
        };
        create: (context: eslint.Rule.RuleContext) => {};
    };
};
declare const configs: {
    recommended: {
        plugins: string[];
        rules: {
            'userscripts/filename-user': ["error", string];
            'userscripts/no-invalid-metadata': ["error", {
                top: string;
            }];
            'userscripts/require-name': ["error", string];
            'userscripts/require-description': ["error", string];
            'userscripts/require-version': ["error", string];
            'userscripts/require-attribute-space-prefix': "error";
            'userscripts/use-homepage-and-url': "error";
            'userscripts/require-download-url': "error";
            'userscripts/align-attributes': ["error", number];
            'userscripts/metadata-spacing': "error";
            'userscripts/no-invalid-headers': "error";
            'userscripts/no-invalid-grant': "error";
            'userscripts/compat-grant': "off";
            'userscripts/compat-headers': "off";
            'userscripts/better-use-match': "warn";
        };
    };
};

export { configs, rules };
