"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var lib_exports = {};
__export(lib_exports, {
  configs: () => configs,
  rules: () => rules
});
module.exports = __toCommonJS(lib_exports);
var import_align_attributes = __toESM(require("./rules/align-attributes"));
var import_better_use_match = __toESM(require("./rules/better-use-match"));
var import_compat_grant = __toESM(require("./rules/compat-grant"));
var import_compat_headers = __toESM(require("./rules/compat-headers"));
var import_filename_user = __toESM(require("./rules/filename-user"));
var import_metadata_spacing = __toESM(require("./rules/metadata-spacing"));
var import_no_invalid_grant = __toESM(require("./rules/no-invalid-grant"));
var import_no_invalid_headers = __toESM(require("./rules/no-invalid-headers"));
var import_no_invalid_metadata = __toESM(require("./rules/no-invalid-metadata"));
var import_require_attribute_space_prefix = __toESM(require("./rules/require-attribute-space-prefix"));
var import_require_description = __toESM(require("./rules/require-description"));
var import_require_download_url = __toESM(require("./rules/require-download-url"));
var import_require_name = __toESM(require("./rules/require-name"));
var import_require_version = __toESM(require("./rules/require-version"));
var import_use_homepage_and_url = __toESM(require("./rules/use-homepage-and-url"));
const rules = Object.fromEntries(
  Object.entries({
    "align-attributes": import_align_attributes.default,
    "better-use-match": import_better_use_match.default,
    "compat-grant": import_compat_grant.default,
    "compat-headers": import_compat_headers.default,
    "filename-user": import_filename_user.default,
    "metadata-spacing": import_metadata_spacing.default,
    "no-invalid-grant": import_no_invalid_grant.default,
    "no-invalid-headers": import_no_invalid_headers.default,
    "no-invalid-metadata": import_no_invalid_metadata.default,
    "require-attribute-space-prefix": import_require_attribute_space_prefix.default,
    "require-description": import_require_description.default,
    "require-download-url": import_require_download_url.default,
    "require-name": import_require_name.default,
    "require-version": import_require_version.default,
    "use-homepage-and-url": import_use_homepage_and_url.default
  }).map(([ruleName, ruleMeta]) => {
    return [
      ruleName,
      {
        ...ruleMeta,
        meta: {
          ...ruleMeta.meta,
          docs: {
            ...ruleMeta.meta.docs,
            url: `https://yash-singh1.github.io/eslint-plugin-userscripts/#/rules/${ruleName}`
          }
        }
      }
    ];
  })
);
const configs = {
  recommended: {
    plugins: ["userscripts"],
    rules: {
      "userscripts/filename-user": ["error", "always"],
      "userscripts/no-invalid-metadata": ["error", { top: "required" }],
      "userscripts/require-name": ["error", "required"],
      "userscripts/require-description": ["error", "required"],
      "userscripts/require-version": ["error", "required"],
      "userscripts/require-attribute-space-prefix": "error",
      "userscripts/use-homepage-and-url": "error",
      "userscripts/require-download-url": "error",
      "userscripts/align-attributes": ["error", 2],
      "userscripts/metadata-spacing": "error",
      "userscripts/no-invalid-headers": "error",
      "userscripts/no-invalid-grant": "error",
      "userscripts/compat-grant": "off",
      "userscripts/compat-headers": "off",
      "userscripts/better-use-match": "warn"
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  configs,
  rules
});
