import * as estree from 'estree';
import { Rule } from 'eslint';

declare const _default: {
    meta: {
        type: "suggestion";
        docs: {
            description: string;
            category: string;
        };
        messages: {
            metadataRequired: string;
            moveMetadataToTop: string;
            noClosingMetadata: string;
            noCodeBetween: string;
            attributeNotStartsWithAtTheRate: string;
        };
        schema: {
            type: "object";
            properties: {
                top: {
                    enum: string[];
                    default: string;
                };
            };
            additionalProperties: false;
        }[];
    };
    create: (context: Rule.RuleContext) => {
        Program(node: estree.Program): void;
    };
};

export { _default as default };
