import { Comment } from 'estree';

type NonNullish<T> = T extends null ? never : T extends undefined ? never : T;
type NonNullishProps<T extends Comment> = {
    [K in keyof T]-?: NonNullish<T[K]>;
};
type NonNullishComment = NonNullishProps<Comment>;
declare function isNonNullishComment(comment: Comment): comment is NonNullishComment;

export { type NonNullishComment, isNonNullishComment };
